$(document).ready(function() {

    var handlers = {
        close: function(e, element) {
            sharelink && sharelink.linkWindowClose();
        },
        retry: function(e, element) {
            setTimeout(run, 0);
        }
    };

    function bindEvents() {
        $('#BannerContainer').on('click', '[href]', function(e) {
            var href = $(this).attr('href');
            if (handlers[href]) {
                e.preventDefault();
                handlers[href].call(handlers, e, this);
            }
        });
    }

    function run() {
        var wr_url = $('#wr_url').html();
        var url = $('#redirect_url').html();

        $('.banner').hide();
        $('#create-link-banner').show();

        if (wr_url === '') {
            $('.banner').hide();
            $('#generic-error-banner').show();
            return;
        }

        // Generate unique url so that webkit doesnt cache the image
        var imgsrc = wr_url + '/images/inSync-icon-30x30.png?' + Math.random();
        $("<img/>").load(function() {
            var arr = url.split('?');
            //replace all '+' with %2B otherwise server parses + as space 
            url = arr[0] + '?' + arr[1].replace(/\+/g, '%2B');
            window.location.href = url;
        }).error(function() {
            $('.banner').hide();
            $('#generic-error-banner').show();
        }).attr("src", imgsrc);
    }

    // Attach all handlers
    bindEvents();
    // Head start!
    run();

});
