(function(){
    var Controller = function(opts) {
        this.opts = opts;
        this.bindEvents();
        this.getInitialPref();
        CUI.Utils.attachTooltipForEllipsis();
    };
    
    //API Methods
    Controller.prototype = {
        bindEvents : function(){
            var self = this;

            $('.page-load').click(function(e){
                e.preventDefault();
                $('.nav-stacked .active').removeClass('active');
                var page = $(this).attr('page');
                $(this).addClass('active');
                self.load(page);
            });

            $('.container-main').on('click', '.user-action', function(e){
                e.preventDefault();
                e.stopPropagation();
                var page = $(this).attr('page'),
                    view = $(this).attr('view');
                if(typeof $(this).data('client_params') !== 'undefined'){
                    context = CUI.RPC.callmethod(view, $(this).data('client_params'));
                } else {
                    
                    context = CUI.RPC.callmethod(view);
                }
                self.load(page, context);
            });

            // These events handle the scrollbar opacity
            $('div.container-main').on('mouseenter', '.jspScrollable', function(){
                $(this).find('.jspDrag').stop(true, true).animate({'opacity': '1'});
            });
            $('div.container-main').on('mouseleave', '.jspScrollable', function(){
                $(this).find('.jspDrag').stop(true, true).animate({'opacity': '0.5'});
            });
            $('.custom-help-link').click(function(e){
                e.preventDefault();
                CUI.RPC.callmethod('summary.openHelpLink');
            });

            $('.download-links .ios, .download-links .android, .download-links .windows').click(function(e){
                e.preventDefault();
                CUI.RPC.callmethod('summary.openMobileAppLink', {'link' : $(this).attr('href')});
            });
        },
        resumeToggler: function(){
            $('.resume-toggler').addClass('hide');
            $('.pause-toggler').removeClass('hide');
        },
        load: function(page, params) {
            var self = this;
            var data = params || {};
            $(".tipsy").remove();
            data['devicepixelratio'] = window.devicePixelRatio || 1;
            var response = CUI.RPC.callmethod(page, data);
            if (response['status'] != -1 ) { 
                $('#div_content').html(response['html']);
                CUI.Utils.executeFunction(response['init'], window);
            }
        },
        getInitialPref: function() {
            var response = CUI.RPC.callmethod('cuiserver.getInitPref'),
                pref;
            if (response['status'] == 0) {
                pref = response['pref'];
                if (pref === 'share:moveDialog') {
                    $('.page-load.share').click();
                    CUI.Share.showWaitDialog();
                } else if (pref === 'settings:generalTab') {
                    $('.page-load.preferences').click();
                    CUI.Preferences.showGeneralTab();
                } else if (pref === 'settings:networkTab') {
                    $('.page-load.preferences').click();
                    CUI.Preferences.showNetworkTab();
                } else {
                    $('.page-load.summary').click();
                }
            }
        }
    };
    window.Controller = Controller;
})();

$(document).ready(function(){
    CUI.Messages.init();
    CUI.Controller = new Controller();
    CUI.Globals.platform = CUI.RPC.callmethod('summary.getSysPlatform')['platform'];    
    CUI.Utils.attachTooltip();
});
