CUI.MyAccount = {
    init : function(){
        var self = this;
        CUI.Globals.ActiveView = 'myaccount';
        self._bindEvents();
    },
    _bindEvents : function(){
        var self = this;
        self.resetPasswordModal = CUI.Utils.modalDialog('#change-password-dlg');

        $('.reactivate-client').click(function(){            
            var response = CUI.RPC.callmethod('myaccount.reactivateClient');
        });

        $('#btn-change-password').click(function(e){
            e.preventDefault();
            self.resetPasswordDlg();
            self.resetPasswordModal.show();
        });

        $('.druva-home-help-link').click(function(e){
            e.preventDefault();
            CUI.RPC.callmethod('myaccount.openDruvaHomeLink');            
        });

        $('#btn-save-password').click(function(e){
            e.preventDefault();
            self.changePassword(); 
        });
    },

    changePassword: function(){
        var self = this;
        var data  = {};        
        data['rpassword'] = $('#retry-user-password').val();
        data['password'] = $('#user-password').val();
        // To get the translated message in case of some checks failure,
        // let cuiserver perform comparision.
        var response = CUI.RPC.callmethod('myaccount.changePassword', data);
        if (response['status'] == -1){
            CUI.Utils.alertDialog({message: response['msg']});
            $('#user-password').focus();
        } else {
            CUI.Utils.alertDialog({message: response['msg']});
            self.resetPasswordModal.hide();
        }
        self.resetPasswordDlg();
    },
    resetPasswordDlg: function(){
        $('#user-password').val('');
        $('#retry-user-password').val('');                
    }


};

