CUI.Share = {
    init: function() {
        CUI.Globals.ActiveView = 'Share';
        var self = this;
        self.state = [];
        self.bindEvents();
        self.startInterval();
    },
    bindEvents: function() {        
        var self = this;
        $('#share-summary-stats').on('click', ".share-action-pause", function(e){
            CUI.RPC.callmethod('share.pauseShare');
        });
        $('#share-summary-stats').on('click', ".share-action-resume", function(e){
            CUI.RPC.callmethod('share.resumeShare');
        });
        $('.action-button').click(function(e){
            e.preventDefault();
            var method = $(this).attr('action-name');
            CUI.RPC.callmethod(method);
        });

        $('#edit-sharefolder').on('click', function(e){
            e.preventDefault();
            var premsgconfirm = CUI._("A folder named 'inSync Share' will be created inside the folder you select.");
            var postmsgconfirm = CUI._("Data in your current inSync Share folder will be moved to the new location. Are you sure you want to continue?");
            var msgCofirm = "<b>" + premsgconfirm + " </b><br /> <br />" + postmsgconfirm;
            CUI.Utils.alertDialog({
                message: msgCofirm,
                buttons: {
                    'No': function() {},
                    'Yes': function(){
                        $('#cui_util_browse_path_div').addClass('hide');

                        var conf = {
                            getChildren: function(params) {
                                var jsonData = {};
                                if(params.path === '') {
                                    jsonData = self.getRootListing();
                                } else {
                                    params['exclude_external_hdd'] = false;
                                    params['force_new_config'] = true;
                                    jsonData = CUI.UserAction.TreeUtils.listFolderTree(params);
                                }
                                return jsonData;
                            },
                            context: self,
                            settings: {
                                core: {
                                    multiple: false
                                },
                                checkbox: {
                                    visible: false,
                                    cascade: ''
                                }
                            },
                            check_path_hidden: false,
                        };
                        CUI.UserAction.treeView.createJsTree($('#cui_util_browse_dlg .tree-body.sharetree'), conf);
                        $('.insync-share').hide();
                        $('#cui_util_browse_dlg').removeClass('hidden');
                    }
                }
            });
        });

        $('#selective-sync').on('click', function(e){
            e.preventDefault();
            var conf = {
                getChildren: function(params, callback) {
                    params.first_call = true;
                    var jsonData;
                    if(params.path === '') {
                        params['parent_undetermined'] = true;
                    }else{
                        params['exclude_external_hdd'] = false;
                        params['force_new_config'] = true;
                    }
                    CUI.UserAction.TreeUtils.listShareFolderTree(params, callback);
                },
                context: self,
            settings: {
                checkbox: {
                    visible: true,
                    three_state: true,
                    cascade: 'up+down+undetermined',
                    tie_selection: false,
                }
            },
            showfiles: false,
            check_config_exts: true,
            check_path_hidden: false,
            undetermined_background_selection: true,
            }
            $('.insync-share').hide();
            $('.selective-sync-tree').removeClass('hidden');
            var container = $('.selective-sync-tree .tree-container');
            container.on('loaded.jstree', function(e, data){
                $('#root_node > a').each(function() {
                      $(this).click(false);
                      $(this).dblclick(false);
                     });
                container.find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
                container.find('.jstree-wholerow').removeClass( 'background-selected' );
                $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});
                $('.jstree-anchor .jstree-undetermined').each(function(){$($(this).parents('.jstree-anchor')).siblings('.jstree-wholerow').addClass('background-selected');});
            });
            container.on('before_open.jstree', function(e, data){
                if (data.node && data.node.id != '#' && data.node.parent != '#'){
                 if(data.node.state.undetermined == true){
                    $('#'+data.node.id).find('.jstree-icon.jstree-checkbox:first').addClass('partial-node');
                }
                    $('#'+data.node.parent).find('.jstree-icon.jstree-undetermined').addClass('partial-node');
                    $('.partial-node').addClass('jstree-undetermined');
                }
                container.find('.jstree-wholerow').removeClass( 'background-selected' );
                $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});
                $('.jstree-anchor .jstree-undetermined').each(function(){$($(this).parents('.jstree-anchor')).siblings('.jstree-wholerow').addClass('background-selected');});

            });
            container.on('uncheck_node.jstree check_node.jstree', function(e, data){
                $('#sync-tree-view-update').removeClass('disabled');
                data.node.state.undetermined = false;
                var obj = data.node;
                if($.inArray(data.node.id, self.state) === -1){
                    self.state.push(data.node.id);
                }
                if(e.type === 'uncheck_node'){
                    $('#'+data.node.id).find('.jstree-icon.jstree-checkbox:first').removeClass('partial-node');
                    $('#'+data.node.parent).find('.jstree-icon.jstree-checkbox:first').addClass('partial-node');
                    for(i = 0, j = obj.parents.length; i < j; i++) {
                        if(obj.parents[i] != '#'){
                            $('#'+obj.parents[i]).find('.jstree-icon.jstree-checkbox:first').addClass('partial-node');
                        }
                    }
                    $('.partial-node').addClass('jstree-undetermined');
                }else{
                    $('#'+data.node.parent).find('.jstree-icon.jstree-checkbox:first').removeClass('partial-node');
                    $('#'+data.node.id).find('.partial-node').removeClass('partial-node');
                    for(i = 0, j = obj.parents.length; i < j; i++) {
                        if(obj.parents[i] != '#'){
                            $('#'+obj.parents[i]).find('.jstree-icon.jstree-checkbox:first').removeClass('partial-node');
                        }
                    }
                    container.jstree(true)._undetermined();
                }
                container.find('.jstree-wholerow').removeClass( 'background-selected' );
                $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});
                $('.jstree-anchor .jstree-undetermined').each(function(){$($(this).parents('.jstree-anchor')).siblings('.jstree-wholerow').addClass('background-selected');});
            });
                CUI.UserAction.treeView.createJsTree($('.selective-sync-tree .tree-container'), conf);
        });

        $('.selective-sync-tree .tree-container').on('click', '.jstree-node', function(e){
           e.stopPropagation();
           $('.selective-sync-tree .tree-container').find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
           $('.selective-sync-tree .tree-container').find('.jstree-wholerow').removeClass( 'background-selected' );
           $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});
           $('.jstree-anchor .jstree-undetermined').each(function(){$($(this).parents('.jstree-anchor')).siblings('.jstree-wholerow').addClass('background-selected');});
        });

        $('#sync-tree-view-cancel, #cui_util_browse_cancel').on('click', function(e){
            $('.nav-pills .active').click();
        });


        $('#sync-tree-view-update').on('click', function(e){
            var pathFilter = [];
            var tmp_state = self.state;
            var checkboxjstreeInstance = $('.selective-sync-tree .tree-container').jstree(true);
            for (var i = 0; i < tmp_state.length; i++){
                var node = checkboxjstreeInstance.get_node(tmp_state[i]);
                if($('#'+tmp_state[i]).find('.jstree-icon.jstree-checkbox:first').hasClass('jstree-undetermined')){
                        for(j=0; j < node.children.length;j++){
                            if($.inArray(node.children[j], self.state) === -1){
                                self.state.push(node.children[j]);
                            }
                        }
                    }
            }
            for (var i = 0; i < self.state.length; i++){
                var node = checkboxjstreeInstance.get_node(self.state[i]);
                if(node.original.state.checked != checkboxjstreeInstance.is_checked(self.state[i]) ||
                    node.original.state.undetermined != checkboxjstreeInstance.is_undetermined(self.state[i]) ||
                    !node.original.state.checked
                   ){
                    var path = node.li_attr.path;
                   if($('#'+self.state[i]).find('.jstree-icon.jstree-checkbox:first').hasClass('jstree-undetermined')){
                        pathFilter.push('*' + path)
                    }else{
                        pathFilter.push(node.state.checked ? '+' + path : '-' + path);
                    }
                }
            }
            var data = {};
            data['pathFilter'] = JSON.stringify(pathFilter);
            var response = CUI.RPC.callmethod("share.updateSelectiveSyncFolder", data);
            $('.nav-pills .active').click();
            if (response['status'] == -1){
                 $('.share-notify').html(response['msg']).show();
            } else {
                self.state = [];
                $('.share-notify').html(response['msg']).show();
            }

            setTimeout(function(){
                $('.share-notify').fadeOut();
            }, 2000);

        });
        $('#share-notifications').on('click', '.openable-link', function(e){
            e.preventDefault();
            var data = {}, response;
            data['file_path'] = $(this).attr('href');
            response = CUI.RPC.callmethod('share.openFile', data);
        });

        $('#cui_util_browse_save').click(function(e){
            e.preventDefault();
            
            var shareTree = $('#cui_util_browse_dlg .tree-body.sharetree'),
                selctedFolderId = shareTree.jstree('get_selected')[0],
                selectedFolderPath = $('#' + selctedFolderId).attr('path'),
                msgAlert = CUI._('Successfully updated inSync Share location.'),
                response;
            
            if (typeof selctedFolderId === 'undefined') {
                CUI.Utils.alertDialog({
                    message: CUI._('Please select a folder to proceed')
                });
            } else {
                response = CUI.RPC.callmethod('preferences.moveShareLocation', {'path': selectedFolderPath});
                if(response['status'] == -1){
                    CUI.Utils.alertDialog({message: response['msg']});
                } else{
                    $('.nav-pills .active').click();
                    self.showWaitDialog();
                }
            }
        });
    },

    getRootListing: function(){
        var self = this;
        var rootFolders, rootdrivelablel;
        rootdrivelablel = $('#deviceRootFolder').val();
        rootFolders = CUI.UserAction.TreeUtils.listFolderTree({'exclude_external_hdd':false, 'force_new_config':true});
        var fileslist = [];
        var imgPath = ((window.devicePixelRatio || 1) > 1) ? 'img/mycomputer_2x.png' : 'img/mycomputer.png'; 
        fileslist.push(CUI.UserAction.TreeUtils.prepareJsonDataForNode(CUI._(rootdrivelablel), rootdrivelablel, 'open', 'folder', rootFolders, imgPath));
        return fileslist;
    },
    showWaitDialog: function(){
        var self = this;
        var wait = CUI.Utils.waitDialog();
        var headermsg = CUI._('Please wait while we update your inSync Share folder location. This will take a while...'); 
        wait.setHeader(headermsg);
        var footermsg = CUI._('Copying data...');
        wait.setFooter(footermsg);
        wait.show();

        var copyInterval = setInterval(function(){
            var response = CUI.RPC.callmethod('preferences.getShareFolderStatus');
            if(response['status'] == 1){
                clearInterval(copyInterval);
                //$('#add-sharefolder').html(response['ush']);
                wait.hide();
                CUI.Utils.alertDialog({message: response['msg']});
            }
        }, 5000);
    },
    
    refreshShareStatus: function() {
        var isShareViewActive = CUI.Globals.ActiveView === 'Share'; 
        var response = CUI.RPC.callmethod("share.getShareStats");
        var stats, res, isPaused, showPauseButton, showResumeButton;
        if (response['status'] == 0){
            if(isShareViewActive) {
                stats = $.parseJSON(response['stats']);
                stats['tooltipRequired'] = function(msg, len) {
                    return msg.length > len;
                };

                isPaused = stats['isSyncPaused'];
                showPauseButton = !isPaused && stats['syncInProgress'] != 0 && (stats['syncInProgress'] == 4 || stats['syncInProgress'] == 5);
                showResumeButton = isPaused && stats['syncInProgress'] != 0;

                $('#share-summary-stats .status .sync-status-heading')
                    .toggleClass('syncPausedHeading', isPaused)
                    .toggleClass('syncRunningHeading', !isPaused)
                    .html(stats['sslogstrHeading']);
                
                $('#share-summary-stats .status .share-action-resume').toggle(showResumeButton);
                $('#share-summary-stats .status .share-action-pause').toggle(showPauseButton);
                $('#share-summary-stats .status .spinnerImg').toggle(showPauseButton);

                res = $('#details-view-container-tmpl').tmpl(stats);
                $('#share-summary-stats .details-view-container').html(res);
                
                res = $('#notifylist-tmpl').tmpl(stats);
                $('#notifylist-container').html(res);
            }
        }
    },
    startInterval: function() {
        if (CUI.Globals.shareStatsRefreshTimer == null) {
            var self = this;
            self.shareInt = setInterval(self.refreshShareStatus, 1000);
            CUI.Globals.shareStatsRefreshTimer = true;
        }
    },
};