/*
- Add Folder
- Edit Folder
- Filters
*/

CUI.UserAction = {
    init: function() {
        var viewToInitialize = $('#initialized-view').val();
        CUI.UserAction[viewToInitialize].init();
        $( "#filterTabs" ).tabs();
    }
};

CUI.UserAction.TreeUtils = {
    prepareJsonDataForNode: function(title, id, state, rel, children, icon){
        var nodeJson = {
            id:id,
            text: title,
            icon: icon,
            state: {
                opened: state
            },
            children: children
        }
        return nodeJson;
    },

    listFolderTree: function(params){
        var quickconfiglabel, rootdrivelabel, fileslist, response;
        quickconfiglabel  = "Quick Configuration";
        rootdrivelabel =  CUI._("My Computer");
        if (params.path === quickconfiglabel)
            response = CUI.RPC.callmethod("summary.getQuickConfigFolders");
        else if (params.path === rootdrivelabel){
            params.path = "";
            response = CUI.RPC.callmethod("summary.listFolderTree", params);
        }
        else {
            response = CUI.RPC.callmethod("summary.listFolderTree", params);
        }
        fileslist = $.parseJSON(response['fileslist']);        
        return fileslist;
    },

    listShareFolderTree: function(params, callback){
        var quickconfiglabel, rootdrivelabel,  response, rootFolders;
        var fileslist = []
        rootdrivelablel = "inSync Share";
            response = CUI.RPC.callmethod("share.listSelectiveSyncFolderTree", params);
            if(response['error']){
                $('.wait-msg').html('<span class="error-msg"><img src="img/backup_error.png"/>' + response['error'] + '</span>');
                $('.body').addClass('error-bg');
                $('.selective-sync-tree .wait-msg').show();
                $('.selective-sync-tree .tree-container').hide();
            }else if($.parseJSON(response['wait_required']) == true){
                if (params.path === ""){
                $('.selective-sync-tree .wait-msg').show();
                $('.selective-sync-tree .tree-container').hide();
                }
                params.first_call = false;
                var timer = setTimeout(function(){
                CUI.UserAction.TreeUtils.listShareFolderTree(params, callback);
                },1000);
            }
            else{
                var filelist = $.parseJSON(response['fileslist'])
                if (params.path === ""){
                    $('.selective-sync-tree .wait-msg').hide();
                    $('.selective-sync-tree .tree-container').show();
                    var imgPath = response['root_image']
                    rootnode_json = CUI.UserAction.TreeUtils.prepareJsonDataForNode(CUI._(rootdrivelablel), 'root_node', 'open', 'folder', filelist, imgPath);
                    rootnode_json['a_attr'] = {'class' : 'jstree-no-checkboxes'};
                    rootnode_json['state']['checked'] = true;
                    fileslist.push(rootnode_json);
                    callback(fileslist);
                }
                else{
                    callback(filelist);
                }
        }
    },
};

CUI.UserAction.treeView = {
    createJsTree: function($container, config) {
        var getJstreeData = function(obj, callback) {
            var params = {};
            params.path = obj.id === '#' ? '' : $('#' + obj.id).attr('path');
            params.node_id = obj.id;
            // Pass on hidden state to python so that agent does not query for children status and saves listing time
            params.parent_hidden = !! (obj.id === '#' ? false : $('#' + obj.id).attr('hidden'));
            params.parent_checked = (typeof $container.jstree(true) === 'object') ? $container.jstree(true).is_checked(obj) : false;
            params.parent_undetermined = (typeof $container.jstree(true) === 'object') ? $container.jstree(true).is_undetermined(obj) : false;
            params.showfiles = !!config.showfiles;
            params.check_config_exts = !!config.check_config_exts;
            params.check_path_hidden = !!config.check_path_hidden;
            var children = config.getChildren.call(config.context, params, function(children) {
                 callback.call(config.context, children);
            });
            if (children != null) {
                 callback.call(config.context, children);
            }
        }

        var defaults = {
            core: {
                data: getJstreeData,
                strings: {
                    'Loading ...': CUI._('Loading...')
                }
            },
            plugins: ["checkbox", "wholerow"],
            checkbox: {
                visible: true,
                three_state: false,
                cascade: 'down'            }
        }
        var settings = $.extend(true, {}, defaults, config.settings);
        $container.on('after_open.jstree ready.jstree after_close.jstree load_node.jstree', function (e, data) {
            $container.find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
                $container.find('.jstree-wholerow').removeClass( 'background-selected' );
                $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});
                if($container.jstree(true) && config.undetermined_background_selection){
                    $container.jstree(true)._undetermined();
                    $('.jstree-undetermined').each(function(){$($(this).parents('.jstree-anchor')).siblings('.jstree-wholerow').addClass('background-selected');});
                }
        });

        $container.jstree(settings);
    },
    destroyTree: function($tree) {
        if(typeof $tree.jstree(true) === 'object') {
            $tree.jstree(true).destroy();
        }
    },
    jsTreeToPathFilter: function(rootnode, $tree, allow_uncheck_all_checkboxes){
        var path_filter = [];
        var checkboxjstreeInstance = $tree.jstree(true);
        var stack = [];
        stack.push(rootnode);
        while(stack.length !== 0) {
            var node = stack.pop();
            CUI.UserAction.treeView.addPathToPathFilter(checkboxjstreeInstance, path_filter, node);
            if(node.children.length){
                for(var idx = 0; idx <  node.children.length; idx++){
                    var child = checkboxjstreeInstance.get_node(node.children[idx]);
                    if(checkboxjstreeInstance.is_disabled(child)) {
                        continue;
                    }
                    stack.push(child);
                }
            }
        }
        if(!allow_uncheck_all_checkboxes && path_filter.length == 1 && path_filter[0][0] == '-'){
            return [];
        }
        return path_filter;
    },
    addPathToPathFilter: function(treeInstance, path_filter, node){
        isNodeChecked = treeInstance.is_checked(node);
        nodeParent = treeInstance.get_node(node.parent);
        if (node.parent == '#' || (isNodeChecked != treeInstance.is_checked(nodeParent))){
            if (isNodeChecked) {
                path_filter.push("+" + node.li_attr.path);
            }
            else {
                path_filter.push("-" + node.li_attr.path);
            }
        }
    },
    setHeading: function(heading) {
        $('.header-left-container .heading').text(heading);
        CUI.Utils.attachTooltipForEllipsis('.header-container');
    },
    /**
     * Sets breadcrumbs. If `selected` is not given or null, no breadcrumbs are set.
     * If it is a string, that string is treated as path and set as breadcrumbs.
     * Otherwise it should be a jQuery jstree object whose selected node's path 
     * is set as breadcrumbs.
     * Filter icon is by default hidden when selected is not given or null. It can
     * be shown or hidden forcefully by setting forceFilterIcon to true or false.
     */
    setBreadcrumbs: function(selected, forceFilterIcon) {
        var $container = $('.header .breadcrumbs-container'),
            $breadcrumbs = $('.breadcrumb', $container),
            $filterIconContainer = $('.filterIconContainer', $container),
            breadcrumbHeading;
        if (selected == null) {
            $breadcrumbs.hide();
            $filterIconContainer.toggle(!!forceFilterIcon);
        } else {
            if (typeof selected !== 'string') {
                selected = $('#' + selected.jstree('get_selected')).attr('path');
            }
            breadcrumbHeading = CUI.Utils.htmlEncode(selected).split("/").join('<i class="glyphicon glyphicon-chevron-right arrow"></i> ');
            if (CUI.Globals.platform !== 'win32' && selected[0] === '/') {
                breadcrumbHeading = '<i class="glyphicon glyphicon-hdd"></i> ' + breadcrumbHeading;
            }
            $breadcrumbs.html(breadcrumbHeading).show();
            if (forceFilterIcon == null || forceFilterIcon) {
                $filterIconContainer.show();
            } else {
                $filterIconContainer.hide();
            }
            CUI.Utils.attachTooltipForEllipsisHtml($container);
        }
    },

    getModifiedFolderPreferences : function(jstree_ident, allow_uncheck_all_checkboxes, client_params){
        /* 
            Provided client params holds minimal information about the folder getting added / modified. 
            It's up the developer to ensure that attrs accessed from client_params provided from all
            callers.
        */
        var syncAll, response, pathFilter,
        checkboxjstreeInstance = $(jstree_ident).jstree(true),
        folder_preferences = {};
        folder_preferences['backup_folderid'] = client_params.backup_folderid;
        syncAll = $('input[type=radio]:checked', 'form.backup-settings-form').val();
        if(syncAll === 'yes'){
            folder_preferences['includeTypes'] = '*;*.*';
            folder_preferences['excludeTypes'] = '';
            folder_preferences['excludeFolders'] = $('.advsettings-excluded-paths').val();                        
        } else {
            folder_preferences['includeTypes'] = $('.advsettings-included-extensions').val();
            folder_preferences['excludeTypes'] = $('.advsettings-excluded-extensions').val();
            folder_preferences['excludeFolders'] = $('.advsettings-excluded-paths').val();
        }
        folder_preferences['pathSelection'] = [];
        if(checkboxjstreeInstance){
            var rootnode = checkboxjstreeInstance.get_node(checkboxjstreeInstance.get_node('#').children[0]);
            var pathFilter = CUI.UserAction.treeView.jsTreeToPathFilter(rootnode, $(jstree_ident), allow_uncheck_all_checkboxes);
            if(!allow_uncheck_all_checkboxes && (!pathFilter || pathFilter.length == 0)){
                CUI.Utils.alertDialog({
                    message: CUI._("Please choose atleast one file/folder for backup")
                });
            } else{
                folder_preferences['pathSelection'] = JSON.stringify(pathFilter);    
            }
        }
        return folder_preferences;
    },

    showFileTypeContainer: function(){
        var container = $('.file-types-container');
        container.show();
        container.removeClass('disabledContainer');
        $(".advanced-settings").removeClass('disabledContainer');
    },
    hideFileTypeContainer: function(){
        var container = $('.file-types-container');
        container.hide();
        container.addClass('disabledContainer');
        $(".advanced-settings").addClass('disabledContainer');
    },
    updateIncludeEtxs: function(eventsource){
        var i, j, len, includedexts = $('.advsettings-included-extensions').val().trim(),
        filterList = CUI.Globals.Filters,
        len = filterList.length;
        if (includedexts === "")
            includedexts = []
        else
            includedexts = includedexts.split(";");

        ischecked = $(eventsource).attr('checked');
        filetype = $(eventsource).attr('name');
        for (i = 0; i < len; i++){
            if(filterList[i]['t'] == filetype)
                break;
        }
        exts = filterList[i]['e'].split(';');
        for(j = 0; j < exts.length; j++){
            var includeIdx = $.inArray(exts[j], includedexts);
            //type is checked.
            if(ischecked != undefined){
                if (includeIdx == -1)
                    includedexts.push(exts[j]);
            } else {
                if (includeIdx != -1)
                    includedexts.splice(includeIdx, 1);
            }
        }
        $('.advsettings-included-extensions').val(includedexts.join(';'));
    },
    toggleHiddenItems: function(){
        var tree = $('.tree-body');
        if ($('#chkHidden').is(':checked')){
            tree.removeClass('hide-items');
            tree.find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
        }
        else{
            tree.addClass('hide-items');
            tree.find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
        }
    },
    setFilterIcon: function(){
        var checked = $('#no-all').attr('checked') == 'checked';
        $('#imgFilter').toggleClass('checked', checked);
    },

    initFileFiltersView : function(response, isMandatory) {
        var self = this, includes_extlist, treeAsJson, includeTypes, excludeTypes, excludeFolders;
        includeTypes = response['includeTypes'];
        excludeTypes = response['excludeTypes'];
        excludeFolders = response['excludeFolders'];            
        includes_extlist = includeTypes.split(';');
        if($.inArray('*', includes_extlist) != -1 && $.inArray('*.*', includes_extlist) != -1 && excludeTypes == ''){
            CUI.UserAction.treeView.setFileFilters(includeTypes, true);
            CUI.UserAction.treeView.hideFileTypeContainer();
        }
        else {
            CUI.UserAction.treeView.setFileFilters(includeTypes, false);
            CUI.UserAction.treeView.showFileTypeContainer();
        }
        $('.advsettings-included-extensions').val(includeTypes).attr('readonly', isMandatory);
        $('.advsettings-excluded-extensions').val(excludeTypes).attr('readonly', isMandatory);
        $('.advsettings-excluded-paths').val(excludeFolders).attr('readonly', isMandatory);
    },

    setFileFilters: function(filter_string, syncAll){
        var already, found, filterList, len, i, k, x, filter_number, selections=[];
        if (syncAll == true){
            $('#yes-all', 'form.backup-settings-form').attr('checked', true);
            // Select all filters
            var checkboxes = $('form.backup-settings-form').find('input[type=checkbox]');
            $(checkboxes).each(function(idx, val){
                $(val).attr('checked', true).triggerHandler('click');
            });
            return true;
        }
        $('#no-all', 'form.backup-settings-form').attr('checked', true);
        filterList = CUI.Globals.Filters;
        len = filterList.length;
        var checkboxes = $('form.backup-settings-form').find('input[type=checkbox]');
        $(checkboxes).each(function(idx, val){
            $(val).removeAttr('checked');
        });
        if (filter_string) {
            already = filter_string.split(';');
            for (i = 0 ; i < already.length ; i++) {
                for (filter_number = 0 ; filter_number < len ; filter_number++) {
                    found = -1;
                    x = filterList[filter_number]["e"].split(";");

                    for (k = 0 ; k <  x.length ; k++) {
                        if (already[i] == x[k]) {
                            found = filter_number;
                            break;
                        }
                    }
                    if (found != -1) {
                        if($.inArray(filterList[found]["t"], selections) === -1) {
                            selections.push(filterList[found]["t"]);
                            $('#chk-'+filterList[found]["t"], 'form.backup-settings-form').attr('checked', 'checked');
                        }
                        break;
                    }
                }
            }
        }
    },
};

CUI.UserAction.addTree = {
    init: function(){
        var self = this;
        // reset folder config in agent
        CUI.RPC.callmethod('summary.reset_state_for_folder_configuration');
        self.identifier = null;
        self.bindEvents();
        self.createClassicTree();
        self.setClassicTreeState();
        self.setUserFolderDefaultFilters();
    },
    setUserFolderDefaultFilters : function() {
        var self = this;
        // set default exclusions
        var response = CUI.RPC.callmethod('summary.get_user_folder_default_filters');
        $('.advsettings-included-extensions').val(response.includeTypes);
        $('.advsettings-excluded-extensions').val(response.excludeTypes);
        $('.advsettings-excluded-paths').val(response.excludeFolders);
        self.includeTypes = response.includeTypes;
        self.excludeTypes = response.excludeTypes;
        self.excludeFolders = response.excludeFolders;
        CUI.UserAction.treeView.initFileFiltersView(response, false);
    },
    bindEvents: function(){
        var self = this,
        classicTree = $('.tree-view .tree-body.classic'),
        checkboxTree = $('.tree-view .tree-body.checkbox');
        $('#chkHidden').click(function(e){
            CUI.UserAction.treeView.toggleHiddenItems();
        });

        $('.wizard').on('click', '.jstree-node', function(e){
           e.stopPropagation();
           checkboxTree.find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
           checkboxTree.find('.jstree-wholerow').removeClass( 'background-selected' );
           $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});
        });

        $('#classic-tree-view-cancel').click(function(e){
            e.preventDefault();
            $('.nav-pills .active').click();
        });

        $('#checkbox-tree-view-cancel').click(function(e){
            e.preventDefault();
            $('.nav-pills .active').click();
        });

        $('#tree-view-next').click(function(e){
            self.setUserFolderDefaultFilters();
            var result = self.initSelectedFolderPreferenceConfigurationView(e, self);
            if(result !== false){
                self.animateWizardLeft();
            }
        });

        $("#tree-view-add").click( function(e){
            e.preventDefault();
            self.addFolder();
        });

        $('#tree-view-prev').click(function(e) {
            e.preventDefault();
            var checkboxTree = $('.tree-view .tree-body.checkbox');
            self.animateWizardRight(function(){
                self.setClassicTreeState();
                CUI.UserAction.treeView.destroyTree(checkboxTree);
            });
        });

        $("#filterIcon").click(function(e){
            e.preventDefault();
            self.includeTypes = $('.advsettings-included-extensions').val().trim();
            self.excludeTypes = $('.advsettings-excluded-extensions').val().trim();
            self.excludeFolders = $('.advsettings-excluded-paths').val().trim();
            self.filterAllFiles = $('input[name=all-files-radio]:checked').val() === "yes";
            var conf= {'left' : 210, 'top' : 30, onLoad: function() {
                CUI.UserAction.treeView.setFileFilters($('.advsettings-included-extensions').val(), self.filterAllFiles);
                if(self.filterAllFiles) {
                    CUI.UserAction.treeView.hideFileTypeContainer();
                } else {
                    CUI.UserAction.treeView.showFileTypeContainer();
                }
                // set global exclusions
                var response = CUI.RPC.callmethod('summary.get_global_filters');
                $("#excludeFilter").val(response.globalFilterExcludes);
                $('#excludeFolder').val(response.globalFolderExcludes);
            }};

            CUI.Utils.modalDialog('#filter-window',conf).show();
        });

        $("#downloadsArrow .advFilter, #downloadsArrow .rightArrow, #downloadsArrow .downArrow ").click(function(e){
                $(this).parent().toggleClass("expandFilters");
                e.stopPropagation();
        });

        $('input[type=checkbox]', '.file-types-container').on('click', function(e){
            CUI.UserAction.treeView.updateIncludeEtxs(e.currentTarget);
        });

        $('.table-container-parent-div').on('click', '.settings-data a.edit', function(e){
            e.preventDefault();
            selected_row = $(e.currentTarget).parent('td').parent('tr');
            backup_folderid =  selected_row.attr('data-share-id');
            email_client = selected_row.attr('data-email-client');
            isMandatory = $(this).closest('tr').find('td.folder-name a').hasClass('mandatory');
            $(this).data({
                client_params: {
                    action: 'show-settings-view',
                    backup_folderid: backup_folderid,
                    email_client: email_client,
                    is_mandatory: isMandatory
                }
            });
        });

        $('form.backup-settings-form .fields.query').on('click', function(e){
            if($('input[name=all-files-radio]').is(':disabled')) {
                return false;
            }
            var selectedVal = $('input[name=all-files-radio]:checked').val();
            if(selectedVal === "yes"){
                CUI.UserAction.treeView.hideFileTypeContainer();
            }else{
                var include_exts = $('.advsettings-included-extensions').val();
                include_exts = include_exts.split(';');
                if($.inArray('*', include_exts) != -1)
                    include_exts.splice($.inArray('*', include_exts), 1);
                if($.inArray('*.*', include_exts) != -1)
                    include_exts.splice($.inArray('*.*', include_exts), 1);
                $('.advsettings-included-extensions').val(include_exts.join(';'));

                CUI.UserAction.treeView.setFileFilters($('.advsettings-included-extensions').val(), false);
                CUI.UserAction.treeView.showFileTypeContainer();
            }
        });

        $('#tree-view-cancel').on('click', function(e){
            $('.advsettings-included-extensions').val(self.includeTypes);
            $('.advsettings-excluded-extensions').val(self.excludeTypes);
            $('.advsettings-excluded-paths').val(self.excludeFolders);
            $('#yes-all').get(0).checked = self.filterAllFiles;
            $('#no-all').get(0).checked = !self.filterAllFiles;
            CUI.UserAction.treeView.setFileFilters($('.advsettings-included-extensions').val(), self.filterAllFiles);
        });

        $('#tree-view-save').click(function() {
            var syncAll, response, pathFilter, response,
                selctedFolderId = $('.tree-view .tree-body.classic').jstree('get_selected'),
                data = {}, client_params, checkbox_tree_tdent, treeAsJson;
            client_params = {'backup_folderid': selctedFolderId};
            checkbox_tree_tdent = '.tree-view .tree-body.checkbox';
            data = CUI.UserAction.treeView.getModifiedFolderPreferences(checkbox_tree_tdent, true, client_params);

            CUI.RPC.callmethod("summary.update_current_folder_config_filters", data);
            response = CUI.RPC.callmethod("summary.reload_folder_configuration", data);
            treeAsJson = $.parseJSON(response['treeAsJson']);
            self.createCheckboxTree(treeAsJson, false);
        });
    },

    createClassicTree: function() {
        var self = this;
        var conf = {
            getChildren: function(params) {
                var jsonData = {};
                if(params.path === '') {
                    jsonData = self.initAddFolder()
                } else {
                    jsonData = CUI.UserAction.TreeUtils.listFolderTree(params)
                }
                return jsonData;
            },
            context: self,
            settings: {
                core: {
                    multiple: false
                },
                checkbox: {
                    visible: false,
                    cascade: ''
                }
            },
            check_path_hidden: true

        }
        CUI.UserAction.treeView.createJsTree($('.tree-view .tree-body.classic'), conf);
        CUI.UserAction.treeView.setFilterIcon();
    },

    getSelectedRootFolderListing: function(){
        var self = this,
        classicTree = $('.tree-view .tree-body.classic');
        var selctedFolderId = classicTree.jstree('get_selected');
        var selectedFolderPath = $('#' + selctedFolderId).attr('path');
        var selectedNode = classicTree.jstree(true).get_node(selctedFolderId);
        var showfiles = true;
        var check_config_exts = true;
        var parent_checked = true;
        var check_path_hidden = true;
        jsonData = CUI.UserAction.TreeUtils.listFolderTree({'path': selectedFolderPath, 
                            'showfiles': showfiles, 'check_config_exts': check_config_exts,
                            'parent_checked': parent_checked, 'check_path_hidden': check_path_hidden});

        var root = {
            text: selectedNode.text,
            icon: selectedNode.icon,
            state: {
                opened: true
            },
            li_attr: {
                path: selectedNode.li_attr.path,
                dname: selectedNode.li_attr.dname,
                identifier: selectedNode.li_attr.identifier
            },
            children: jsonData
        }
        return root;
    },

    createCheckboxTree: function(treeAsJson, check_root) {
        //Destroy the existing checkbox tree as someone wants to redraw it
        CUI.UserAction.treeView.destroyTree($('.tree-view .tree-body.checkbox'));
        var self = this,
            classicTree = $('.tree-view .tree-body.classic'),
            checkboxTree = $('.tree-view .tree-body.checkbox');

        var conf = {
            getChildren: function(params) {
                if(!checkboxTree.jstree(true)) {
                    return [treeAsJson];
                } else{
                    return CUI.UserAction.TreeUtils.listFolderTree(params);
                }
            },
            context: self,
            settings: {
                checkbox: {
                    visible: true,
                    cascade: 'down',
                    tie_selection: false
                }
            },
            showfiles: true,
            check_config_exts: true,
            check_path_hidden: true
        }
        checkboxTree.on('loaded.jstree', function(e, data){
            /**
                Check root node if drawing checkbox tree after seleting root folder.
                Should honor the check preferences given by agent if redrawing tree
                on fitlers get modified/updated by user.
            */
            if (check_root === true){
                var parent_node = data.instance.get_node('#').children[0];
                data.instance.check_node(parent_node);
            }
            checkboxTree.find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
            checkboxTree.find('.jstree-wholerow').removeClass( 'background-selected' );
            $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});
        });
        CUI.UserAction.treeView.createJsTree($('.tree-view .tree-body.checkbox'), conf);

        self.setCheckboxTreeState();
        checkboxTree.find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
        checkboxTree.find('.jstree-wholerow').removeClass( 'background-selected' );
        $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});
        CUI.UserAction.treeView.setFilterIcon();
    },

    initSelectedFolderPreferenceConfigurationView: function(e, self){
        e.preventDefault();
        var classicTree = $('.tree-view .tree-body.classic'),
            selctedFolderId = classicTree.jstree('get_selected')[0],
            selectedFolderPath = $('#' + selctedFolderId).attr('path');

        if (typeof selctedFolderId === 'undefined') {
            CUI.Utils.alertDialog({
                message: CUI._('Please select a folder to backup')
            });
            return false;
        } else {
            CUI.RPC.callmethod('summary.update_current_folder_config_filters', {'dir': selectedFolderPath});
            if (selectedFolderPath === 'Email') {
                var response = CUI.RPC.callmethod('summary.listEmailClients');
                if (response['status'] == 0){
                    $('.tree-view .tree-body.email').html(response['html']);
                    self.setEmailState();
                } else {
                    CUI.Utils.alertDialog({message: response['msg']});
                }
            } else {
                self.identifier = classicTree.jstree('get_selected', true)[0].li_attr.identifier;
                var selected_folder_listing = self.getSelectedRootFolderListing();
                self.createCheckboxTree(selected_folder_listing, true);
            }
        }

    },

    initAddFolder: function(){
        var self = this;
        var quick_configs, rootFolders, quickconfiglabel, rootdrivelablel;
        quickconfiglabel = 'Quick Configuration';
        rootdrivelablel = $('#deviceRootFolder').val();
        quick_configs = CUI.UserAction.TreeUtils.listFolderTree({path: quickconfiglabel});
        rootFolders = CUI.UserAction.TreeUtils.listFolderTree({});
        var fileslist = [];
        if((window.devicePixelRatio || 1) > 1) {
            quick_config_img_path = 'img/quick_config_2x.png';
            mycomp_img_path = 'img/mycomputer_2x.png';
        }else {
            quick_config_img_path = 'img/quick_config.png';
            mycomp_img_path = 'img/mycomputer.png';
        }
        fileslist.push(CUI.UserAction.TreeUtils.prepareJsonDataForNode(CUI._(quickconfiglabel), quickconfiglabel, 'open', 'folder', quick_configs, quick_config_img_path));
        fileslist.push(CUI.UserAction.TreeUtils.prepareJsonDataForNode(CUI._(rootdrivelablel), rootdrivelablel, 'open', 'folder', rootFolders, mycomp_img_path));
        return fileslist;

    },

    setClassicTreeState: function() {
        var self = this;
        $('.tree-view .classic').show();
        $('.tree-view .checkbox').hide();
        $('.tree-view .tree-body.email').hide();
        $('.header-right-container').css('visibility', 'visible');
        CUI.UserAction.treeView.setHeading(CUI._('Select Folder'));
        CUI.UserAction.treeView.setBreadcrumbs(null);
        CUI.UserAction.treeView.toggleHiddenItems();
    },
    setCheckboxTreeState: function() {
        var self = this;
        var classicTree = $('.tree-view .tree-body.classic');
        $('.tree-view .classic:not(.tree-body)').hide();
        $('.tree-view .checkbox').show();
        $('.tree-view .tree-body.email').hide();
        $('.header-right-container').css('visibility', 'visible');
        CUI.UserAction.treeView.setHeading(CUI._('Select Items To Backup'));
        CUI.UserAction.treeView.setBreadcrumbs(classicTree); // node is selected from previous tree
        CUI.UserAction.treeView.toggleHiddenItems();
    },
    setEmailState: function() {
        var self = this;
        $('.tree-view .classic:not(.tree-body)').hide();
        $('.tree-view .checkbox:not(.tree-body)').show();
        $('.tree-view .tree-body.email').show();
        $('.header-right-container').css('visibility', 'hidden');
        CUI.UserAction.treeView.setHeading(CUI._('Select Email Client To Backup'));
        CUI.UserAction.treeView.setBreadcrumbs(null);
    },

    addFolder: function() {
        var self = this;
        if($('.tree-body.email').is(':visible')){
            var email_client_id = $('.email-backup-client').val();
            var data = {}, response;
            data['email_client_id'] = email_client_id;
            response = CUI.RPC.callmethod('summary.checkEmailClientConfig', data);
            if (response['status'] == 0){
                if(response['msg']){
                    CUI.Utils.alertDialog({message: response['msg']});
                    return false;
                }
                response = '';
                response = CUI.RPC.callmethod('summary.addEmailClient', data);
                if (response['status'] == -1){
                    CUI.Utils.alertDialog({message: response['msg']});
                } else {
                    $('.nav-pills .active').click();
                }
            } else {
                CUI.Utils.alertDialog({message: response['msg']});
            }
        } else {
            var checkboxjstreeInstance = $('.tree-view .tree-body.checkbox').jstree(true);
            var rootnode = checkboxjstreeInstance.get_node(checkboxjstreeInstance.get_node('#').children[0]);
            var pathFilter = CUI.UserAction.treeView.jsTreeToPathFilter(rootnode, $('.tree-view .tree-body.checkbox'), false);
            if (!pathFilter || pathFilter.length == 0) {
                CUI.Utils.alertDialog({message: CUI._("Please choose atleast one file/folder for backup")});
            } else {
                var backup_folderid = rootnode.li_attr.dname;
                var params = {'backup_folderid': backup_folderid}
                var result = CUI.RPC.callmethod("summary.getBackupFolderId", params);
                var data = {};
                data['path_filter'] = JSON.stringify(pathFilter);
                data['backup_folder_identity'] = self.identifier || '';
                data['backup_folderid'] = result['backup_folderid'];
                data['includeTypes'] = $('.advsettings-included-extensions').val();
                data['excludeTypes'] = $('.advsettings-excluded-extensions').val();
                data['excludeFolders'] = $('.advsettings-excluded-paths').val();
                var response = CUI.RPC.callmethod("summary.addBackupFolder", data);
                $('.nav-pills .active').click();
            }
        }
    },

    animateWizardLeft: function() {
        $('.wizard').animate({
            left: '-520px'
        })
    },

    animateWizardRight: function(callback){
        var self = this;
        $('.wizard').animate({
            left: '0'
        }, 400, function(){
            callback.call(self);
        })
    }
};

CUI.UserAction.editTree = {
    init: function() {
        var self = this;
        var params = $('#client_params').data('client-params');
        self.initializeEditFolder(params);
        self.bindEvents();
    },
    bindEvents: function() {
        var self = this;

        $("#downloadsArrow .advFilter, #downloadsArrow .rightArrow, #downloadsArrow .downArrow").click(function(e){
                $(this).parent().toggleClass("expandFilters");
                e.stopPropagation();
        });
        $('#chkHidden').click(function(e){
            CUI.UserAction.treeView.toggleHiddenItems();
        });

        $('.tree-body.tree-checkbox-view').on('click', '.jstree-node', function(e){
           e.stopPropagation();
           $('.tree-body.tree-checkbox-view').find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
           $('.tree-body.tree-checkbox-view').find('.jstree-wholerow').removeClass( 'background-selected' );
           $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});
        });
        $('#edit-tree-view-delete').on('click', function(){
            var data = {}, response, deleteFolder, email_dname;
            var params = $('#client_params').data('client-params');
            var share_id = params.backup_folderid;
            var email_client = params.email_client;
            data['backup_folderid'] = share_id;
            if(email_client == 1){
                email_dname = $('#email-display-name').text();
            }
            CUI.Utils.alertDialog({
                message: (email_client == 1) ? CUI._("Are you sure you want to delete email client") + " '" + email_dname + "'?"
                            : CUI._("Are you sure you want to remove folder") + " '" + share_id + "'?",
                buttons: {
                    'No': function() {},
                    'Yes': function(){
                        if (email_client == 1){
                            response = CUI.RPC.callmethod('summary.deleteEmailClient', data);
                        }
                        else {
                            response = CUI.RPC.callmethod('summary.deleteBackupFolder', data);
                        }
                        if (response['status'] == -1){
                            CUI.Utils.alertDialog({
                                message: response['msg'],
                                buttons: {
                                    'Ok': function(){
                                        $('.nav-pills .active').click();
                                    }
                                }
                            });
                        } else {
                            $('.nav-pills .active').click();
                        }
                    }
                }
            });
        });

        $('#edit-tree-view-cancel').click(function() {
            $('.nav-pills .active').click();
        });

        $('#edit-tree-view-save').click( function(){
            var data, response, client_params, checkbox_tree_tdent;
            client_params = $('#client_params').data('client-params');
            checkbox_tree_tdent = '.edit-tree-view .tree-body.tree-checkbox-view';
            data = CUI.UserAction.treeView.getModifiedFolderPreferences(checkbox_tree_tdent, false, client_params);
            if (!data['pathSelection'] || data['pathSelection'].length == 0)
                return false;
            response = CUI.RPC.callmethod("summary.updateBackupFolder", data);
            $('.nav-pills .active').click();
        });

        $('#tree-view-cancel').on('click', function(e){
            $('.advsettings-included-extensions').val(self.includeTypes);
            $('.advsettings-excluded-extensions').val(self.excludeTypes);
            $('.advsettings-excluded-paths').val(self.excludeFolders);
            $('#yes-all').get(0).checked = self.filterAllFiles;
            $('#no-all').get(0).checked = !self.filterAllFiles;
            CUI.UserAction.treeView.setFileFilters($('.advsettings-included-extensions').val(), self.filterAllFiles);
        });

        $('#tree-view-save').on('click', function() {
            var checkbox_tree_tdent, data, client_params, checkboxTree, response;
            checkbox_tree_tdent = '.edit-tree-view .tree-body.tree-checkbox-view';
            client_params = $('#client_params').data('client-params');
            data = CUI.UserAction.treeView.getModifiedFolderPreferences(checkbox_tree_tdent, true, client_params);
            CUI.RPC.callmethod("summary.update_current_folder_config_filters", data);
            checkboxTree = $(checkbox_tree_tdent);
            CUI.UserAction.treeView.destroyTree(checkboxTree);
            response = CUI.RPC.callmethod("summary.reload_folder_configuration", data);
            if (response['status'] == 0){
                self.editBackupFolderTree(response, response['isMandatory'], true);
            } else {
                CUI.Utils.alertDialog({message: response['msg']});
            }
        });

        $("#filterIcon").click(function(e){
            e.preventDefault();
            self.includeTypes = $('.advsettings-included-extensions').val().trim();
            self.excludeTypes = $('.advsettings-excluded-extensions').val().trim();
            self.excludeFolders = $('.advsettings-excluded-paths').val().trim();
            self.filterAllFiles = $('input[name=all-files-radio]:checked').val() === "yes";
            var conf= {'left' : 210, 'top' : 30, onLoad: function() {
                CUI.UserAction.treeView.setFileFilters($('.advsettings-included-extensions').val(), self.filterAllFiles);
                if(self.filterAllFiles) {
                    CUI.UserAction.treeView.hideFileTypeContainer();
                } else {
                    CUI.UserAction.treeView.showFileTypeContainer();
                }
                // set global exclusions
                var response = CUI.RPC.callmethod('summary.get_global_filters');
                $("#excludeFilter").val(response.globalFilterExcludes);
                $('#excludeFolder').val(response.globalFolderExcludes);
            }};

            CUI.Utils.modalDialog('#filter-window',conf).show();
        });

        $('form.backup-settings-form .fields.query').on('click', function(e){
            if($('input[name=all-files-radio]').is(':disabled')) {
                return false;
            }
            var selectedVal = $('input[name=all-files-radio]:checked').val();
            if(selectedVal === "yes"){
                CUI.UserAction.treeView.hideFileTypeContainer();
            }else{
                var include_exts = $('.advsettings-included-extensions').val();
                include_exts = include_exts.split(';');
                if($.inArray('*', include_exts) != -1)
                    include_exts.splice($.inArray('*', include_exts), 1);
                if($.inArray('*.*', include_exts) != -1)
                    include_exts.splice($.inArray('*.*', include_exts), 1);
                $('.advsettings-included-extensions').val(include_exts.join(';'));
                CUI.UserAction.treeView.setFileFilters($('.advsettings-included-extensions').val(), false);
                CUI.UserAction.treeView.showFileTypeContainer();
            }
        });

        $('input[type=checkbox]', '.file-types-container').on('click', function(e){
            CUI.UserAction.treeView.updateIncludeEtxs(e.currentTarget);
        });

        self.advancedSettingsModal = CUI.Utils.modalDialog('#advanced-settings-window',{
            expose: {
                zIndex: 1001
            }
        });
    },

    initializeEditFolder: function(params){
        var self = this;
        var backup_folderid, email_client, isMandatory;
        backup_folderid =  params.backup_folderid;
        email_client = params.email_client;
        isMandatory = params.is_mandatory;
        if (email_client == 1){
            self.editEmailClient(email_client, backup_folderid, isMandatory);
        } else {
            var data = {};
            data['backup_folderid'] = backup_folderid;
            var response = CUI.RPC.callmethod('summary.getBackupFolderConfiguration', data);
            if(response['status'] == 0){
                CUI.UserAction.treeView.initFileFiltersView(response, isMandatory);
                self.editBackupFolderTree(response, isMandatory);
                // Remove following code while cleaning-up
                if(response['isOutlookFolder']){
                    $('.edit-tree-view .footer #edit-tree-view-delete').hide();
                }
            } else {
                CUI.Utils.alertDialog({message: response['msg']});
            }
        }
    },
    createEditFolderTree: function(treeAsJson, is_mandatory) {
        var self = this,
            checkboxTree = $('.edit-tree-view .tree-body.tree-checkbox-view');
        var conf = {
            getChildren: function(params) {
                if(!checkboxTree.jstree(true)) {
                    return treeAsJson;
                }
                return CUI.UserAction.TreeUtils.listFolderTree(params);
            },
            context: self,
            settings: {
                checkbox: {
                    visible: true,
                    cascade: 'down',
                    tie_selection: false,
                    editable: !is_mandatory,
                }
            },
            showfiles: true,
            check_config_exts: true,
            check_path_hidden: true
        }
        CUI.UserAction.treeView.createJsTree(checkboxTree, conf);
        checkboxTree.on('loaded.jstree', function(e, data){
            var parent_node = data.instance.get_node('#').children[0];
            data.instance.get_node(parent_node).hasLoaded = true;
            checkboxTree.find('.jstree-wholerow').removeClass('wholerow-even').filter(':visible:even').addClass('wholerow-even');
            checkboxTree.find('.jstree-wholerow').removeClass( 'background-selected' );
            $('.jstree-anchor.jstree-checked').each(function(){$(this).siblings('.jstree-wholerow').addClass('background-selected');});

        });
        CUI.UserAction.treeView.setFilterIcon();
        CUI.UserAction.treeView.toggleHiddenItems();
    },
    editBackupFolderTree: function(response, isMandatory, reinitialize) {
        var self = this,
            $checkboxTree = $('.edit-tree-view .tree-body.tree-checkbox-view'),
            $basicView = $('.edit-tree-view .tree-body.basic-folder-view'),
            treeAsJson;

        if (!reinitialize) {
            CUI.UserAction.treeView.setHeading(response['display_name']);
        }

        if(response['load_tree']) {
            treeAsJson = $.parseJSON(response['treeAsJson']);
            self.createEditFolderTree(treeAsJson, isMandatory);
            self.showEditViewElements($checkboxTree);
            self.mandatoryFolderSetup(isMandatory);
            CUI.UserAction.treeView.setBreadcrumbs(treeAsJson.li_attr['path']);
        } else {
            $basicView.html(response['html']);
            self.showEditViewElements($basicView);
            self.mandatoryFolderSetup(isMandatory);
            $('#edit-tree-view-save').hide();
            $('.header-right-container').css('visibility', 'hidden');
            CUI.UserAction.treeView.setBreadcrumbs(response['title'], !response['excluded_share']);
        }
    },

    editEmailClient: function(email_client, backup_folderid, isMandatory) {
        var response, data = {}, self = this;
        data['eclient_id'] = backup_folderid;
        response = CUI.RPC.callmethod('summary.renderSelectedEmailClientInfo', data);  
        if(response['status'] == 0){
            $('.edit-tree-view .tree-body.email-client-view').html(response['html']);                
            self.showEditViewElements($('.edit-tree-view .tree-body.email-client-view'));                          
            self.mandatoryFolderSetup(isMandatory);
            $('#edit-tree-view-save').hide();
            $('.header-right-container').css('visibility', 'hidden');
            CUI.UserAction.treeView.setBreadcrumbs(null);
            CUI.UserAction.treeView.setHeading(CUI._('Email Configuration'));
        } else {
            CUI.Utils.alertDialog({message: response['msg']});
        }
    },
    showEditViewElements: function($container){
        $('.edit-tree-view > .tree-body').hide();
        $container.show();
    },
    mandatoryFolderSetup: function(isMandatory) {
        if(!isMandatory){
            $('.edit-tree-view .mandatory-msg').hide();
            $('.settings-view form.backup-settings-form input').attr('disabled', false);
            $('#edit-tree-view-delete,#edit-tree-view-save,#tree-view-save').show();
        } else {
            $('.edit-tree-view .mandatory-msg').show();
            $('.settings-view form.backup-settings-form input').attr('disabled', true);
            $('#edit-tree-view-delete,#edit-tree-view-save,#tree-view-save').hide();
        }
    },
};




